| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | ## |
| 4 | # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U. |
| 5 | # This file is part of openmano |
| 6 | # All Rights Reserved. |
| 7 | # |
| 8 | # Licensed under the Apache License, Version 2.0 (the "License"); you may |
| 9 | # not use this file except in compliance with the License. You may obtain |
| 10 | # a copy of the License at |
| 11 | # |
| 12 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 13 | # |
| 14 | # Unless required by applicable law or agreed to in writing, software |
| 15 | # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT |
| 16 | # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the |
| 17 | # License for the specific language governing permissions and limitations |
| 18 | # under the License. |
| 19 | # |
| 20 | # For those usages not covered by the Apache License, Version 2.0 please |
| 21 | # contact with: nfvlabs@tid.es |
| 22 | ## |
| 23 | |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 24 | #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 25 | #Get needed packages, source code and configure to run openmano |
| 26 | #Ask for database user and password if not provided |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 27 | |
| 28 | function usage(){ |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame^] | 29 | echo -e "usage: sudo -E $0 [OPTIONS]" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 30 | echo -e "Install last stable source code in ./openmano and the needed packages" |
| 31 | echo -e "On a Ubuntu 16.04 it configures openmano as a service" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 32 | echo -e " OPTIONS" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 33 | echo -e " -u USER: database admin user. 'root' by default. Prompts if needed" |
| 34 | echo -e " -p PASS: database admin password to be used or installed. Prompts if needed" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 35 | echo -e " -q --quiet: install in unattended mode" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 36 | echo -e " -h --help: show this help" |
| 37 | echo -e " --develop: install last version for developers, and do not configure as a service" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 38 | echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 39 | echo -e " --updatedb: do not reinstall mano_db DB if it exists, just update database" |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 40 | echo -e " --force: makes idenpotent, delete previous installations folders if needed. It assumes --updatedb if --forcedb option is not provided" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 41 | echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo" |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 42 | echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation" |
| garciadeblas | 5b1a664 | 2017-04-18 10:10:31 +0200 | [diff] [blame] | 43 | echo -e " --no-db: do not install mysql server" |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 44 | } |
| 45 | |
| 46 | function install_packages(){ |
| 47 | [ -x /usr/bin/apt-get ] && apt-get install -y $* |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 48 | [ -x /usr/bin/yum ] && yum install -y $* |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 49 | |
| 50 | #check properly installed |
| 51 | for PACKAGE in $* |
| 52 | do |
| 53 | PACKAGE_INSTALLED="no" |
| 54 | [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes" |
| 55 | [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes" |
| 56 | if [ "$PACKAGE_INSTALLED" = "no" ] |
| 57 | then |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 58 | echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2 |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 59 | exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 60 | fi |
| 61 | done |
| 62 | } |
| 63 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 64 | function ask_user(){ |
| 65 | # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive |
| 66 | # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed |
| 67 | # Return: true(0) if user type 'yes'; false (1) if user type 'no' |
| 68 | read -e -p "$1" USER_CONFIRMATION |
| 69 | while true ; do |
| 70 | [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0 |
| 71 | [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1 |
| 72 | [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0 |
| 73 | [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1 |
| 74 | read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION |
| 75 | done |
| 76 | } |
| 77 | |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 78 | GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 79 | GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git |
| tierno | 4da1c24 | 2017-09-28 12:17:05 +0200 | [diff] [blame] | 80 | GIT_OSMIM_URL=https://osm.etsi.org/gerrit/osm/IM.git |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 81 | DBUSER="root" |
| 82 | DBPASSWD="" |
| 83 | DBPASSWD_PARAM="" |
| 84 | QUIET_MODE="" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 85 | DEVELOP="" |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 86 | DB_FORCE_UPDATE="" |
| 87 | UPDATEDB="" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 88 | FORCE="" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 89 | NOCLONE="" |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 90 | NO_PACKAGES="" |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 91 | NO_DB="" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 92 | |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 93 | while getopts ":u:p:hiq-:" o; do |
| 94 | case "${o}" in |
| 95 | u) |
| 96 | export DBUSER="$OPTARG" |
| 97 | ;; |
| 98 | p) |
| 99 | export DBPASSWD="$OPTARG" |
| 100 | export DBPASSWD_PARAM="-p$OPTARG" |
| 101 | ;; |
| 102 | q) |
| 103 | export QUIET_MODE=yes |
| 104 | export DEBIAN_FRONTEND=noninteractive |
| 105 | ;; |
| 106 | h) |
| 107 | usage && exit 0 |
| 108 | ;; |
| 109 | -) |
| 110 | [ "${OPTARG}" == "help" ] && usage && exit 0 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 111 | [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 112 | [ "${OPTARG}" == "forcedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--forcedb" && continue |
| 113 | [ "${OPTARG}" == "updatedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--updatedb" && continue |
| 114 | [ "${OPTARG}" == "force" ] && FORCE="y" && continue |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 115 | [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 116 | [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 117 | [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 118 | [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 119 | echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 120 | exit 1 |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 121 | ;; |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 122 | \?) |
| 123 | echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2 |
| 124 | exit 1 |
| 125 | ;; |
| 126 | :) |
| 127 | echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2 |
| 128 | exit 1 |
| 129 | ;; |
| 130 | *) |
| 131 | usage >&2 |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 132 | exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 133 | ;; |
| 134 | esac |
| 135 | done |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 136 | |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 137 | if [ "$DB_FORCE_UPDATE" == "--forcedb--updatedb" ] || [ "$DB_FORCE_UPDATE" == "--updatedb--forcedb" ] ; then |
| 138 | echo "Error: options --forcedb and --updatedb are mutually exclusive" >&2 |
| 139 | exit 1 |
| 140 | elif [ -n "$FORCE" ] && [ -z "$DB_FORCE_UPDATE" ] ; then |
| 141 | DB_FORCE_UPDATE="--updatedb" |
| 142 | fi |
| 143 | |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 144 | #check root privileges and non a root user behind |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 145 | [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 146 | if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]] |
| 147 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 148 | [[ -z $QUIET_MODE ]] && ! ask_user "Install in the root user (y/N)? " n && echo "Cancelled" && exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 149 | export SUDO_USER=root |
| 150 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 151 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 152 | # Discover Linux distribution |
| 153 | # try redhat type |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 154 | [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1) |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 155 | # if not assuming ubuntu type |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 156 | [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null) |
| 157 | if [ "$_DISTRO" == "Ubuntu" ] |
| 158 | then |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 159 | _RELEASE=$(lsb_release -rs) |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 160 | if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]] |
| 161 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 162 | [[ -z $QUIET_MODE ]] && |
| 163 | ! ask_user "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)' (y/N)? " n && |
| 164 | echo "Cancelled" && exit 1 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 165 | _RELEASE = 14 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 166 | fi |
| 167 | elif [ "$_DISTRO" == "CentOS" ] |
| 168 | then |
| 169 | _RELEASE="7" |
| 170 | if ! cat /etc/redhat-release | grep -q "7." |
| 171 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 172 | [[ -z $QUIET_MODE ]] && |
| 173 | ! ask_user "WARNING! Not tested CentOS version. Continue assuming a '$_RELEASE' type (y/N)? " n && |
| 174 | echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 175 | fi |
| 176 | elif [ "$_DISTRO" == "Red" ] |
| 177 | then |
| 178 | _RELEASE="7" |
| 179 | if ! cat /etc/redhat-release | grep -q "7." |
| 180 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 181 | [[ -z $QUIET_MODE ]] && |
| 182 | ! ask_user "WARNING! Not tested Red Hat OS version. Continue assuming a '$_RELEASE' type (y/N)? " n && |
| 183 | echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 184 | fi |
| 185 | else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ] |
| 186 | _DISTRO_DISCOVER=$_DISTRO |
| 187 | [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14" |
| 188 | [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 189 | [[ -z $QUIET_MODE ]] && |
| 190 | ! ask_user "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type (y/N)? " n && |
| 191 | echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 192 | fi |
| 193 | |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 194 | #check if installed as a service |
| 195 | INSTALL_AS_A_SERVICE="" |
| 196 | [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 197 | |
| 198 | # Next operations require knowing BASEFOLDER |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 199 | if [[ -z "$NOCLONE" ]]; then |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 200 | if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 201 | BASEFOLDER=__openmano__${RANDOM} |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 202 | else |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 203 | BASEFOLDER="${PWD}/openmano" |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 204 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 205 | [[ -n "$FORCE" ]] && rm -rf $BASEFOLDER #make idempotent |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 206 | else |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 207 | HERE=$(dirname $(readlink -f ${BASH_SOURCE[0]})) |
| 208 | BASEFOLDER=$(dirname $HERE) |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 209 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 210 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 211 | if [[ -z "$NO_PACKAGES" ]] |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 212 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 213 | echo -e "\n"\ |
| 214 | "#################################################################\n"\ |
| 215 | "##### UPDATE REPOSITORIES #####\n"\ |
| 216 | "#################################################################" |
| 217 | [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 218 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 219 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame^] | 220 | [ "$_DISTRO" == "CentOS" ] && yum install -y epel-release |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 221 | [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \ |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame^] | 222 | && rpm -ivh epel-release-7-5.noarch.rpm && yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm |
| 223 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum repolist |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 224 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 225 | echo -e "\n"\ |
| 226 | "#################################################################\n"\ |
| 227 | "##### INSTALL REQUIRED PACKAGES #####\n"\ |
| 228 | "#################################################################" |
| 229 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client" |
| 230 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client" |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 231 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 232 | echo -e "\n"\ |
| 233 | "#################################################################\n"\ |
| 234 | "##### INSTALL PYTHON PACKAGES #####\n"\ |
| 235 | "#################################################################" |
| gcalvino | e580c7d | 2017-09-22 14:09:51 +0200 | [diff] [blame] | 236 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip python-crypto" |
| 237 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip python-crypto" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 238 | # The only way to install python-bottle on Centos7 is with easy_install or pip |
| 239 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 240 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 241 | # required for vmware connector TODO move that to separete opt in install script |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame^] | 242 | pip install --upgrade pip |
| 243 | pip install pyvcloud |
| 244 | pip install progressbar |
| 245 | pip install prettytable |
| 246 | pip install pyvmomi |
| bayramov | fe3f3c9 | 2016-10-04 07:53:41 +0400 | [diff] [blame] | 247 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 248 | # required for AWS connector |
| 249 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto" |
| 250 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exists with this name, or PIP should be used |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 251 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 252 | # install openstack client needed for using openstack as a VIM |
| tierno | b4c2239 | 2017-06-14 12:55:38 +0200 | [diff] [blame] | 253 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient "\ |
| 254 | "python-neutronclient python-cinderclient python-openstackclient" |
| 255 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install \ |
| 256 | python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient \ |
| 257 | python-openstackclient #TODO revise if gcc python-pip is needed |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 258 | fi # [[ -z "$NO_PACKAGES" ]] |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 259 | |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 260 | if [[ -z $NOCLONE ]]; then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 261 | echo -e "\n"\ |
| 262 | "#################################################################\n"\ |
| 263 | "##### DOWNLOAD SOURCE #####\n"\ |
| 264 | "#################################################################" |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 265 | if [[ -d "${BASEFOLDER}" ]] ; then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 266 | if [[ -n "$FORCE" ]] ; then |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 267 | echo "deleting '${BASEFOLDER}' folder" |
| 268 | rm -rf "$BASEFOLDER" #make idempotent |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 269 | elif [[ -z "$QUIET_MODE" ]] ; then |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 270 | ! ask_user "folder '${BASEFOLDER}' exists, overwrite (y/N)? " n && echo "Cancelled!" && exit 1 |
| 271 | rm -rf "$BASEFOLDER" |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 272 | else |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 273 | echo "'${BASEFOLDER}' folder exists. Use "--force" to overwrite" >&2 && exit 1 |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 274 | fi |
| 275 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 276 | su $SUDO_USER -c "git clone ${GIT_URL} ${BASEFOLDER}" |
| tierno | 6e8b5a8 | 2017-05-26 11:20:48 +0200 | [diff] [blame] | 277 | LATEST_STABLE_TAG=`git -C "${BASEFOLDER}" tag -l v[0-9].* | tail -n1` |
| 278 | [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${BASEFOLDER} checkout tags/${LATEST_STABLE_TAG}" |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 279 | su $SUDO_USER -c "cp ${BASEFOLDER}/.gitignore-common ${BASEFOLDER}/.gitignore" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 280 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 281 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 282 | echo -e "\n"\ |
| 283 | "#################################################################\n"\ |
| tierno | 4da1c24 | 2017-09-28 12:17:05 +0200 | [diff] [blame] | 284 | "##### INSTALLING OSM-IM LIBRARY #####\n"\ |
| 285 | "#################################################################" |
| 286 | su $SUDO_USER -c "git -C ${BASEFOLDER} clone ${GIT_OSMIM_URL} IM" |
| 287 | LATEST_STABLE_TAG=`git -C "${BASEFOLDER}/IM" tag -l v[0-9].* | tail -n1` |
| tierno | d8b6bb9 | 2017-10-06 09:51:26 +0200 | [diff] [blame] | 288 | [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${BASEFOLDER}/IM checkout tags/${LATEST_STABLE_TAG}" |
| tierno | 4da1c24 | 2017-09-28 12:17:05 +0200 | [diff] [blame] | 289 | |
| 290 | # Install debian dependencies before setup.py |
| 291 | if [[ -z "$NO_PACKAGES" ]] |
| 292 | then |
| 293 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "tox debhelper python-bitarray" |
| 294 | # TODO check packages for CentOS and RedHat |
| 295 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "tox debhelper python-bitarray" |
| 296 | pip install stdeb pyangbind |
| 297 | fi |
| 298 | su $SUDO_USER -c "make -C ${BASEFOLDER}/IM all" |
| 299 | dpkg -i ${BASEFOLDER}/IM/deb_dist/python-osm-im*.deb ${BASEFOLDER}/IM/pyangbind/deb_dist/*.deb \ |
| 300 | ${BASEFOLDER}/IM/pyang/deb_dist/*.deb |
| 301 | rm -rf "${BASEFOLDER}/IM" |
| 302 | OSM_IM_PATH=`python -c 'import osm_im; print osm_im.__path__[0]'` || |
| 303 | ! echo "ERROR installing python-osm-im library!!!" >&2 || exit 1 |
| 304 | |
| 305 | |
| 306 | echo -e "\n"\ |
| 307 | "#################################################################\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 308 | "##### INSTALLING OVIM LIBRARY #####\n"\ |
| 309 | "#################################################################" |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 310 | su $SUDO_USER -c "git -C ${BASEFOLDER} clone ${GIT_OVIM_URL} openvim" |
| tierno | 5acb1e4 | 2017-08-23 16:27:10 +0200 | [diff] [blame] | 311 | LATEST_STABLE_TAG=`git -C "${BASEFOLDER}/openvim" tag -l v[0-9].* | tail -n1` |
| tierno | d8b6bb9 | 2017-10-06 09:51:26 +0200 | [diff] [blame] | 312 | [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${BASEFOLDER}/openvim checkout 005a9dc" |
| 313 | # disable because a problem with this version[[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${BASEFOLDER}/openvim checkout tags/${LATEST_STABLE_TAG}" |
| garciadeblas | e02ee6e | 2017-04-24 13:01:45 +0200 | [diff] [blame] | 314 | |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 315 | # Install debian dependencies before setup.py |
| tierno | 4da1c24 | 2017-09-28 12:17:05 +0200 | [diff] [blame] | 316 | if [[ -z "$NO_PACKAGES" ]] |
| 317 | then |
| 318 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "libmysqlclient-dev" |
| 319 | #TODO check if that is the name in CentOS and RedHat |
| 320 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "libmysqlclient-dev" |
| 321 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 322 | make -C ${BASEFOLDER}/openvim lite |
| 323 | rm -rf "${BASEFOLDER}/openvim" |
| tierno | 4da1c24 | 2017-09-28 12:17:05 +0200 | [diff] [blame] | 324 | OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'` || |
| 325 | ! echo "ERROR installing python-lib-osm-openvim library!!!" >&2 || exit 1 |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 326 | |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 327 | if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] |
| 328 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 329 | echo -e "\n"\ |
| 330 | "#################################################################\n"\ |
| 331 | "##### CONFIGURE firewalld #####\n"\ |
| 332 | "#################################################################" |
| 333 | if [[ -z $QUIET_MODE ]] || ask_user "Configure firewalld for openmanod port 9090 (Y/n)? " y |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 334 | then |
| 335 | #Creates a service file for openmano |
| 336 | echo '<?xml version="1.0" encoding="utf-8"?> |
| 337 | <service> |
| 338 | <short>openmanod</short> |
| 339 | <description>openmanod service</description> |
| 340 | <port protocol="tcp" port="9090"/> |
| 341 | </service>' > /etc/firewalld/services/openmanod.xml |
| 342 | #put proper permissions |
| 343 | pushd /etc/firewalld/services > /dev/null |
| 344 | restorecon openmanod.xml |
| 345 | chmod 640 openmanod.xml |
| 346 | popd > /dev/null |
| 347 | #Add the openmanod service to the default zone permanently and reload the firewall configuration |
| 348 | firewall-cmd --permanent --add-service=openmanod > /dev/null |
| 349 | firewall-cmd --reload > /dev/null |
| 350 | echo "done." |
| 351 | else |
| 352 | echo "skipping." |
| 353 | fi |
| 354 | fi |
| 355 | |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 356 | echo -e "\n"\ |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 357 | "#################################################################\n"\ |
| 358 | "##### CONFIGURE OPENMANO CLIENT #####\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 359 | "#################################################################" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 360 | #creates a link at ~/bin if not configured as a service |
| 361 | if [[ -z "$INSTALL_AS_A_SERVICE" ]] |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 362 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 363 | su $SUDO_USER -c 'mkdir -p ${HOME}/bin' |
| 364 | su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano' |
| 365 | su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report' |
| 366 | su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano' |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 367 | su $SUDO_USER -c "ln -s '${BASEFOLDER}/openmano' "'${HOME}/bin/openmano' |
| 368 | su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report' |
| 369 | su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/service-openmano' "'${HOME}/bin/service-openmano' |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 370 | |
| 371 | #insert /home/<user>/bin in the PATH |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 372 | #skiped because normally this is done authomatically when ~/bin exists |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 373 | #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin" |
| 374 | #then |
| 375 | # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc" |
| 376 | # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc' |
| 377 | #fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 378 | |
| 379 | if [[ $SUDO_USER == root ]] |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 380 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 381 | if ! echo $PATH | grep -q "${HOME}/bin" |
| 382 | then |
| 383 | echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc |
| 384 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 385 | fi |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 386 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 387 | |
| 388 | #configure arg-autocomplete for this user |
| 389 | #in case of minimal instalation this package is not installed by default |
| 390 | [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion |
| 391 | #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d' |
| 392 | su $SUDO_USER -c 'activate-global-python-argcomplete --user' |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 393 | if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 394 | then |
| 395 | echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 396 | su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 397 | fi |
| 398 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 399 | if [ -z "$NO_DB" ]; then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 400 | echo -e "\n"\ |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 401 | "#################################################################\n"\ |
| 402 | "##### INSTALL DATABASE SERVER #####\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 403 | "#################################################################" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 404 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 405 | if [ -n "$QUIET_MODE" ]; then |
| 406 | DB_QUIET='-q' |
| 407 | fi |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 408 | ${BASEFOLDER}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} $DB_QUIET $DB_FORCE_UPDATE || exit 1 |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 409 | echo -e "\n"\ |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 410 | "#################################################################\n"\ |
| 411 | "##### CREATE AND INIT MANO_VIM DATABASE #####\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 412 | "#################################################################" |
| 413 | # Install mano_vim_db after setup |
| 414 | ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db --no-install-packages $DB_QUIET $DB_FORCE_UPDATE || exit 1 |
| 415 | fi # [ -z "$NO_DB" ] |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 416 | |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 417 | if [[ -n "$INSTALL_AS_A_SERVICE" ]] |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 418 | then |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 419 | echo -e "\n"\ |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 420 | "#################################################################\n"\ |
| 421 | "##### CONFIGURE OPENMANO SERVICE #####\n"\ |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 422 | "#################################################################" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 423 | |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 424 | ${BASEFOLDER}/scripts/install-openmano-service.sh -f ${BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"` |
| 425 | # rm -rf ${BASEFOLDER} |
| tierno | 80fde98 | 2017-04-26 14:33:25 +0200 | [diff] [blame] | 426 | # alias service-openmano="service openmano" |
| 427 | # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 428 | echo |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 429 | echo "Done! installed at /opt/openmano" |
| Igor D.C | bf669b9 | 2017-10-23 13:36:03 +0000 | [diff] [blame^] | 430 | echo " Manage server with 'sudo -E service osm-ro start|stop|status|...' " |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 431 | else |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 432 | echo |
| 433 | echo "Done! you may need to logout and login again for loading client configuration" |
| tierno | 070e95f | 2017-05-05 15:55:13 +0200 | [diff] [blame] | 434 | echo " Run './${BASEFOLDER}/scripts/service-openmano start' for starting openmano in a screen" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 435 | fi |